//+------------------------------------------------------------------+
//|                                                         nema.mq4 |
//|                                                           mladen | 
//+------------------------------------------------------------------+
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_color3  DeepSkyBlue
#property indicator_color4  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2

//
//
//
//
//

extern int Nema1Period = 20;
extern int Nema1Price  = PRICE_CLOSE;
extern int Nema1Depth  =  2;
extern int Nema2Period = 50;
extern int Nema2Price  = PRICE_CLOSE;
extern int Nema2Depth  =  2;

//
//
//
//
//

double nema1[];
double nema2[];
double trend[];
double dotUp[];
double dotDn[];
double work1[][50];
double coeff1[50];
double work2[][50];
double coeff2[50];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//
int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,nema1);
   SetIndexBuffer(1,nema2);
   SetIndexBuffer(2,dotUp); SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,159);
   SetIndexBuffer(3,dotDn); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,159);
   SetIndexBuffer(4,trend);
   
         Nema1Depth = MathMax(MathMin(Nema1Depth,49),1);
         Nema2Depth = MathMax(MathMin(Nema2Depth,49),1);
         if (Nema1Period>Nema2Period)
         {
            int temp = Nema1Period;
                       Nema1Period = Nema2Period;
                       Nema2Period = temp;
         }                       
         for(int k=0; k<=Nema1Depth; k++) coeff1[k] = factorial(Nema1Depth)/(factorial(Nema1Depth-k)*factorial(k));
         for(    k=0; k<=Nema2Depth; k++) coeff2[k] = factorial(Nema2Depth)/(factorial(Nema2Depth-k)*factorial(k));
   return(0); 
}
int deinit(){ return(0); }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   double alpha1 = 2.0 / (1.0+Nema1Period);
   double alpha2 = 2.0 / (1.0+Nema2Period);
   int i,k,r,limit, counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(work1,0)!=Bars) { ArrayResize(work1,Bars); ArrayResize(work2,Bars); }
         
   //
   //
   //
   //
   //
    
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      nema1[i] = 0;
      nema2[i] = 0;
 
         //
         //
         //
         //
         //
         //
         
         double price = iMA(NULL,0,1,0,MODE_SMA,Nema1Price,i);
         double sign = 1;
         for (k=0; k<Nema1Depth; k++, sign *= -1)
         {
            if (r<2)
                  work1[r][k] = price;
            else  work1[r][k] = work1[r-1][k]+alpha1*(price-work1[r-1][k]);
            price = work1[r][k];
            nema1[i] += price*sign*coeff1[k+1];
         }            

         //
         //
         //
         //
         //
         
         price = iMA(NULL,0,1,0,MODE_SMA,Nema2Price,i);
         sign  = 1;
         for (k=0; k<Nema2Depth; k++, sign *= -1)
         {
            if (r<2)
                  work2[r][k] = price;
            else  work2[r][k] = work2[r-1][k]+alpha2*(price-work2[r-1][k]);
            price = work2[r][k];
            nema2[i] += price*sign*coeff2[k+1];
         }            

      //
      //
      //
      //
      
      dotUp[i] = EMPTY_VALUE;
      dotDn[i] = EMPTY_VALUE;
      trend[i] = trend[i+1];
         if (nema1[i] > nema2[i]) trend[i] =  1;
         if (nema1[i] < nema2[i]) trend[i] = -1;
         if (trend[i]!= trend[i+1])
            if (trend[i] ==1)
                  dotUp[i] = nema2[i] - iATR(NULL,0,20,i)/2;
            else  dotDn[i] = nema1[i] + iATR(NULL,0,20,i)/2;
   }       
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double factorial(int n)
{
   double a=1; for(int i=1; i<=n; i++) a*=i;
   return(a);
}